    PROGRAM f01fdfe

!      F01FDF Example Program Text
!      Mark 23 Release. NAG Copyright 2011.

!      .. Use Statements ..
       USE nag_library, ONLY : f01fdf, nag_wp, x04daf
!      .. Implicit None Statement ..
       IMPLICIT NONE
!      .. Parameters ..
       INTEGER, PARAMETER              :: nin = 5, nout = 6
!      .. Local Scalars ..
       INTEGER                         :: i, ierr, ifail, lda, n
       CHARACTER (1)                   :: uplo
!      .. Local Arrays ..
       COMPLEX (KIND=nag_wp), ALLOCATABLE :: a(:,:)
!      .. Executable Statements ..
       WRITE (nout,*) 'F01FDF Example Program Results'
       WRITE (nout,*)
       FLUSH (nout)
!      Skip heading in data file
       READ (nin,*)
       READ (nin,*) n
       READ (nin,*) uplo

       lda = n
       ALLOCATE (a(lda,n))

!      Read A from data file

       IF (uplo=='U' .OR. uplo=='u') THEN
          READ (nin,*) (a(i,i:n),i=1,n)
       ELSE
          READ (nin,*) (a(i,1:i),i=1,n)
       END IF

!      Find exp( A )

       ifail = 0
       CALL f01fdf(uplo,n,a,lda,ifail)

!      Print solution

       ierr = 0
       CALL x04daf(uplo,'N',n,n,a,lda,'Hermitian Exp(A)',ierr)

    END PROGRAM f01fdfe
